

MYEMAIL   = "bob@mellowood.ca"  
VALMAIL   =  "val@mellowood.ca"
MYDOMAIN  = "mellowood.ca"


def menubar():
    """Create a tabbed menu bar. No arguments. Intended to be called
       from the PAGEHEADER function.
    """
    
    def lili(ln, tx):
        return li(ln, tx) + "</li>"

    def li(ln, tx):
        return "<li>" + RLINK([ln,tx])


    return '\n'.join([
           """ <div Class="topbox">""",
           """ <div id="menu">""",
           """   <ul> %s </ul>""" % lili('index.html' , 'Mellowood Home') ,

           """   <ul> %s  </ul> """ % lili('music/cedars/index.html', 'Cedars CD'),

           """   <ul> %s """ % li('music/index.html', 'My Music'),
           """    <ul>""",
                    li('music/software.html', 'Software'),
           """      <ul>""",
                     lili('mma/index.html', 'MMA'),
                     lili('countbeats/index.html', 'CountBeats'),
                     lili('xpmidi/index.html', 'XPmidi'),
                     lili('vmusic/index.html', 'Vmusic'),
                     lili('mup/index.html', 'MUP'),
	   """      </ul> """,
           """     </li>""",
                   lili('music/recordings/index.html', 'Recordings'),
                   lili('music/instruments/index.html', 'Instruments'),
                   lili('music/imc.html', 'Music Camp'),
           """    </ul>""",
           """   </li></ul>""",

           """   <ul> %s </ul>""" % lili('software/index.html', 'Software'),

           """   <ul> %s """ % li('documents/index.html', 'Docs/Projects'),
           """    <ul> """,
                   lili('documents/broadband/index.html', 'Wynndel&nbsp;Broadband'),
                   lili('documents/index.html#books', 'Reviews'),
                   lili('documents/button-uses.html', 'Buttons'),
                   lili('documents/index.html#catalogs', 'Catalogs'),
           """    </ul> """,
           """   </li> </ul>""",
           
           """   <ul> %s """ % li('art/index.html', ' Art'),
           """    <ul>""",
                   lili('art/watercolors/index.html', 'Watercolors'),
                   lili('art/acrylic/index.html', 'Acrylics'),
                   lili('art/monochrome/index.html', 'Monochrome'),
                   lili('art/mixed/index.html', 'Mixed&nbsp;Media'),
           """    </ul> """,
           """   </li> </ul>""",

           """  <ul> %s """ % li('about/index.html', 'About'),
           """   <ul> """,
                   lili('about/mellowood.html', 'Mellowood'),
		   lili('about/bob.html', 'Bob'),
                   lili('about/val.html', ' Val'),
                   lili('about/site.html', ' Site'),
           """   </ul> """,
           """  </li> </ul>""",

           """ <ul> % s""" % li('about/contact.html', 'Contact Us'),
           """ </li> </ul> </div> """ ] )


def PAGEHEADER(p):
    """Create a HTML page header. This will set up the various html top-of-file
       data and calls a function to create a tabbed menu. This is specific to
       my web pages. You should write your own!

       args - single arg with the title of the page.
    """

    if len(p) != 1:
        error("PAGEHEADER: Need <title>.")
    title = p[0]

#    fname = expfile.split('.')[-2] + ".html"
    fname = HTMLFILE
    ret = ["""<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"> """,
           """<HTML>""",
           """<HEAD>""",
           """<META HTTP-EQUIV="Content-Style-Type" Content="text/css; charset=UTF-8">""",
           """<LINK HREF="%s/index.css" rel="stylesheet" type="text/css" media="screen, projection">""" % (ROOTDIR),
           """<META NAME="keywords" CONTENT="Bob van der Poel %s">""" % title,
           """<META NAME="description" CONTENT="Bob van der Poel's Web Pages">""",
           """<META NAME="author" CONTENT="Bob van der Poel">""",
           """<META NAME="rating" CONTENT="General">""",
           """<META NAME="url" CONTENT="Bob van der Poel's Home Page">""",
           """<META NAME="location" CONTENT="Wynndel, British Columbia, Canada">""",
           """<META NAME="version" CONTENT="2">""",
           """<META HTTP-EQUIV="Reply-to" CONTENT="%s">""" % MYEMAIL ,
           """<TITLE> %s </TITLE>""" % title,
           """</HEAD>""",
           """ """,
           menubar(),
           """ <br clear=all>""",
           """ </div>""",
           """ <DIV ID=content>"""
           ]
    
    return '\n'.join(ret)



#######################
## Various headers

def MYH1(p):
    """A H1 Header line with increased font size (deprecated, use css).

       args - any number permitted.
    """ 

    return "<CENTER>  <H1> <FONT SIZE = \"+5\"> %s </FONT>  </H1>  </CENTER> " % ' '.join(p)


def MYH2(p):
    """A H2 Header line with increased font size (deprecated, use css).

       args - any number permitted.
    """

    return "<CENTER>  <H2> <FONT SIZE = \"+3\"> %s </FONT>  </H2>  </CENTER> " % ' '.join(p)


def MYH3(p):
    """A H3 Header line with increased font size (deprecated, use css).

       args - any number permitted.
    """

    return "<CENTER>  <H3> <FONT SIZE = \"+2\"> %s </FONT>  </H3>  </CENTER> " % ' '.join(p)

def HRULE(p):
    """Return a new paragraph and hrule line.

       args - none permitted.
    """

    if p:
        error("HRULE: no args permitted.")

    return "\n<p><hr><p>\n"


##################################
# Links 

def MAILTO(p):
    """A mailto link. 

       args -  "email address" [printable text].
               if no printable text passed the address is
               used as the printable.
    """

    if not p:
        error("MAILTO: arg count error: <email> [printable].")

    who=p[0]
    if len(p) > 1:
        printable = ' '.join(p[1:])
    else:
        printable = who
    
    return  """<a href="mailto:%s">%s</a>""" % (who, printable)


def LINK(p):
    """Return a basic html link. 

       args -  "<http address> [printable text].
               if no printable text passed the address is
               used as the printable.
    """

    if not p:
        error("LINK: link [text].")

    url=p[0]
    if len(p) > 1:
        text = ' '.join(p[1:])
    else:
        text = url

    return """<a href="%s">%s</a>""" % (url, text)

def RLINK(p):
    """Return an html link relative to the root directory. 

       NOTE: the current value of ROOTDIR is inserted into the address.

       args -  "http address" [printable text].
               if no printable text passed the address is
               used as the printable.

    """

    if not p or len(p)>2:
        error("RLINK: link [text]")
    p[0] = "%s/%s" % (ROOTDIR, p[0])
    return LINK(p)


def IMGLINK(p):
    """Format an image as a url link. 

       args - "url" "name of image" [options]
              options are joined can have details like "border=2", etc.
          
    """

    if len(p)<2:
        error("IMGLINK: at least 2 args needed. <url> <image> [stuff]")

    return  """<A href="%s"> %s </a>""" % (p[0], IMAGE( p[1:]) )


def IMGLINKMAIL(p):
    """Format an image as a mailto link.

       args - "email address" "name of image" [options]
              options are joined can have details like width="50%", etc.
    """

    if len(p)<2:
        error("IMGLINKMAIL: at least 2 args needed. <email> <image> [stuff]")

    return MAILTO([p[0], IMAGE(p[1:])] )


##################################
# Display an image. Not a big saving,
# but using macros in the source makes
# it easy to turn a pic into a link at
# a latter time.

def IMAGE(p):
    """Format an image link.

       args - <image source> [Alt-text] [stuff]
    """

    if not p:
        error("IMAGE: needs at least 1 arg.")

    if len(p)>1:
        alt="""Alt="%s" """ % p[1]
    else:
        alt=""

    return """<Img src="%s" %s %s>""" % (p[0], alt, ' '.join(p[2:]) )

######################
# My divisions


def MYTBSTART(p):
    """ Start a block. Just a short cut for "div class=box".

        args - [location]  creates a local link point
    """

    if len(p)>1:
        error("MYTBSTART: [location].")

    if len(p):
        loc = """<a name=\"%s\"></a>""" % p[0]
    else:
        loc = ''
        
    return """%s\n<div class="box"> """ % loc


def MYTBEND(p):
    """ End a block. Just a consistant way to say "/div"."""

    if p:
        error("MYTBEND: no args.")

    return """</div>"""

def MYBOX(p):
    """Create a box with MYTBSTART and MYTBEND.

       args - <location> [text]

       Note: unlike MYTBSTART the location is madatorty.
    """


    if len(p) < 2:
        error("MYBOX: <loc> <text>")

    loc = p[0]
    text = ' '.join(p[1:])
    
    return  "%s\n%s\n%s" % ( MYTBSTART([loc]), text, MYTBEND([]) )



##################################################
# Create a box for a download.
# name (stripped of the dir) is printed with the
# word "Download"


def DLLINE(p):
    """Download line for files. Pretty specific for bvdp.

       args - <filename>

    """

    import os
    
    if len(p) != 1:
        error("DLLINE: expecting 1 arg.")

    f = p[0]
    sz = os.path.getsize(f)

    if sz >= 1024000:
        sz = "%.1fMEG" % (sz / 1024000.)
    elif sz > 1024:
        sz = "%dK"  % (sz / 1024)
    else:
        sz = "%s BYTES" % sz
        
    txt = "Download (%s): %s" % (sz, f)

    return """<P><Table CellPadding=8 Align=Right Border=5 BGcolor=#f0f0f0> <Tr> <Td>
             %s 
            </Td></Tr> </Table> <BR> """ % LINK([f, txt])

def DLBOX(p):
    """Create a box for a download.

       args - <title> <filename> <location name> <text>
 
    """
    
    if len(p) < 4:
        error("DLBOX: needs <name> <file> <loc> [text]")
    
    name = p[0]
    f = p[1]
    loc = p[2]
    txt = ' '.join(p[3:])

    return """ %s <h3> %s </h3> %s %s %s """ % \
        (MYTBSTART([loc]), name, txt, DLLINE([f]), MYTBEND([]) )
 

##########################
# A comment macro

def COMMENT(p):
    """Ignores its argument. """

    return ""



##### HOOKS 
#####  If these exist, they are included before and after file processing.


def hook_start():
    """Top of file hook. Called before any other processing. """

    return ''

def hook_eof():
    """End of file hook. Called after all other processing. """

    import time

    return """
   <p> %s   
   <Table align=right border=0> <tr><td>
   This page \"%s" was last modified on  %s
   </td></tr></Table> <br>
   </div></body> \n </html> 
    """ % ( IMGLINKMAIL([MYEMAIL, ROOTDIR+"/images/bob-web.jpg", \
                             "Web Design--Bob van der Poel", 'Width="25%"', 'Align=Left'] ),
            HTMLFILE,
            time.asctime() )




##### System functions

def GETSYS(p):
    """ Execute system command and return result. 

        args -  system command to execute (ie. "ls -l")
    """

    import commands

    return  commands.getoutput( ' '.join(p) )

    
